MountCheck = {
	MountCheck_Data = {},
	Mountcheckcount = 0,
	getlistcount = 0,
	dropdownSelect = 1,
	dropdownDisplay = 1,
	MountList = {},
	NoMountList = {},
	NoPetList = {},
	PetList = {},
	CheckList = {},
	PetCheckList = {},
	FastLandMounts = {},
	FastFlyingMounts = {},
	LandMounts = {},
	FlyingMounts = {},
	Sortnum = 0;
}
	
function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

function MountCheck_OnLoad()
  --out("MountCheck: OnLoad");
  SLASH_MOUNTCHECK1 = "/mc";
  SLASH_MOUNTCHECK2 = "/mountcheck";
  SlashCmdList["MOUNTCHECK"] = function(msg)
		MountCheck_SlashCommandHandler(msg);
	end	
  MountCheck_LoadHandler();
end

function MountCheck_LoadHandler()
	local frame = CreateFrame("FRAME", "MountCheckEventWatcher");
	frame:RegisterEvent("COMPANION_LEARNED");
	local function eventHandler(self, event, ...)
		MountCheck.getlistcount = 0;
		if(getglobal("MountCheck1"):IsVisible()) then
			MountCheck.getMountList();
			MountCheck.ShowScroll();
		end
	end
	frame:SetScript("OnEvent", eventHandler);
end

function MountCheck_SlashCommandHandler(msg)
    --out("MountCheck: " .. msg)
	--if (msg == "0") then
	-- ReloadUI();
	--end
	if(msg=="pet") then
		SummonRandomCritter();
	elseif(msg=="land") then
		MountCheck.LandMount();
	elseif(msg=="flying") then
		MountCheck.FlyingMount();
	else
	--if (msg == "go") then
	 MountCheck.MountCheck_Frame();
	end
end
	
function MountCheck.TestSort() --table sorts: A > a -- only 1 var type can be sorted
	--[[local a = {{"a", "test"}, {"z", "boat"}, {"cab", "candy"}};
	for i=1,#a do
		out(a[i][1].." "..a[i][2]);
	end
	--table.sort(a[1]);
	table.sort(a, function(x,y) return x[2] < y[2] end)
	for i=1,#a do
		out(a[i][1].." "..a[i][2]);
	end]]
	
	--table.sort(MountList[1]);
	table.sort(MountCheck.MountList, function(x,y) return x[6] < y[6] end)
	MountCheck.ShowScroll();
end	

function MountCheck.SortBy(tablename, num)
	local function testsort(x,y)
		local z = x[num];
		local f = y[num];
		if(string.find(x[num], "|", 1))then 
			if((strsub(x[num], 11, 11)=="[")or(strsub(x[num], 11, 11)=="(")) then
				z = strsub(x[num], 12);
			else
				z = strsub(x[num], 11);
			end
		end
		if(string.find(y[num], "|", 1))then 
			if((strsub(y[num], 11, 11)=="[")or(strsub(y[num], 11, 11)=="(")) then
				f = strsub(y[num], 12);
			else
				f = strsub(y[num], 11);
			end
		end
		return z < f;
	end
	local function testsort2(x,y)
		local z = x[num];
		local f = y[num];
		if(string.find(x[num], "|", 1))then
			if((strsub(x[num], 11, 11)=="[")or(strsub(x[num], 11, 11)=="(")) then
				z = strsub(x[num], 12);
			else
				z = strsub(x[num], 11);
			end
		end
		if(string.find(y[num], "|", 1))then 
			if((strsub(y[num], 11, 11)=="[")or(strsub(y[num], 11, 11)=="(")) then
				f = strsub(y[num], 12);
			else
				f = strsub(y[num], 11);
			end
		end
		return z > f;
	end
	if(MountCheck.Sortnum == 0) then --sort a>z
		table.sort(tablename, testsort);
	else --sort z>a
		table.sort(tablename, testsort2);
	end
	MountCheck.ShowScroll();
end

function MountCheck.Sort(SortButton, num, num2)
	if(MountCheck.dropdownSelect==1) then --mount
		if(MountCheck.dropdownDisplay==1) then --collected
			MountCheck.Sortnum = 1 - MountCheck.Sortnum;
			MountCheck.SortBy(MountCheck.MountList, num);
		else --not collected
			MountCheck.Sortnum = 1 - MountCheck.Sortnum;
			MountCheck.SortBy(MountCheck.NoMountList, (num-num2));
		end
	else --pets
		if(MountCheck.dropdownDisplay==1) then --collected
			MountCheck.Sortnum = 1 - MountCheck.Sortnum;
			MountCheck.SortBy(MountCheck.PetList, num);
		else --not collected
			MountCheck.Sortnum = 1 - MountCheck.Sortnum;
			MountCheck.SortBy(MountCheck.NoPetList, (num-num2));
		end
	end
	MountCheck.UpdateArrows(SortButton);
end
	
function MountCheck.UpdateArrows(ClickedFrame)
	if(ClickedFrame:GetName() == "MountSortName") then
		getglobal(ClickedFrame:GetName().."Arrow"):Show();
		getglobal("MountSortSourceArrow"):Hide();
	else
		getglobal(ClickedFrame:GetName().."Arrow"):Show();
		getglobal("MountSortNameArrow"):Hide();
	end
	if(MountCheck.Sortnum == 0) then
		getglobal(ClickedFrame:GetName().."Arrow"):SetTexCoord(0, 0.5625, 0, 1.0);
	else
		getglobal(ClickedFrame:GetName().."Arrow"):SetTexCoord(0, 0.5625, 1.0, 0);
	end	
end	
	
function MountCheck.LandMount()
	if(MountCheck.getlistcount==0) then
		MountCheck.getMountList();
	end
	if(#MountCheck.FastLandMounts > 0) then
		local x = random(#MountCheck.FastLandMounts);
		CallCompanion("MOUNT", MountCheck.FastLandMounts[x][7]);
	else
		if(#MountCheck.LandMounts > 0) then
			local x = random(#MountCheck.LandMounts);
			CallCompanion("MOUNT", MountCheck.LandMounts[x][7]);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Mount Check: No Land Mounts to use.");
		end
	end
	--out("Slow land: "..#MountCheck.LandMounts.." fast: "..#MountCheck.FastLandMounts);
end

function MountCheck.FlyingMount()
	local druid=0;
	if(MountCheck.getlistcount==0) then
		MountCheck.getMountList();
	end
	if(#MountCheck.FastFlyingMounts > 0) then		
		local x = random(#MountCheck.FastFlyingMounts)
		CallCompanion("MOUNT", MountCheck.FastFlyingMounts[x][7]);
	else
		if(#MountCheck.FlyingMounts > 0) then
			local x = random(#MountCheck.FlyingMounts+druid);
			CallCompanion("MOUNT", MountCheck.FlyingMounts[x][7]);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Mount Check: No Flying mounts to use.");
		end
	end
	--out("Slow flying: "..#MountCheck.FlyingMounts.." fast: "..#MountCheck.FastFlyingMounts);
end
function MountCheck.MountCheck_Frame()
	local frame = getglobal("MountCheck1");
	if (frame) then
		if(frame:IsVisible()) then
			frame:Hide();
		else
			frame:Show();
			if(MountCheck.Mountcheckcount==0) then
				MountCheck.createDropdown1();
				MountCheck.createDropdown2();
				MountCheck.getMountList();
			else
				if not(MountCheck_DropDownMenu) then
					MountCheck.createDropdown1();
				else
					MountCheck_DropDownMenu:Show();
				end
				
				if not(MountCheck_DropDownMenu2) then
					MountCheck.createDropdown2();
				else
					MountCheck_DropDownMenu2:Show();
				end
			end
			MountCheck.ShowScroll();
		end
	end
end

function MountCheck.ShowScroll()
	MountCheck_ScrollBar:Hide();
	if(MountCheck.getlistcount==0)then
		MountCheck.getMountList();
	end
	MountCheck_ScrollBar:Show();
	getglobal("MountSortNameArrow"):Show();
	getglobal("MountSortSourceArrow"):Hide();
	getglobal("MountSortNameArrow"):SetTexCoord(0, 0.5625, 0, 1.0);
end

function MountCheck.ReloadModList()
MountCheck.getMountList();
MountCheck.ShowScroll();
out("Mount List Reloaded.");
end

function MountCheck.getMountList()
local x=1;
local z=1;
local a=1;
local b=1;
local c=1;
local d=1;--Fastland, slowland, fastflight, slowflight
	for i=1,GetNumCompanions("MOUNT") do
		MountCheck.MountList[i] = {}
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
		MountCheck.MountList[i][1] = creatureName;
		MountCheck.MountList[i][2] = creatureSpellID;
		MountCheck.MountList[i][3] = icon;
		MountCheck.MountList[i][99] = i;
	end
	for i=1,GetNumCompanions("CRITTER") do
		MountCheck.PetList[i] = {}
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i);
		MountCheck.PetList[i][1] = creatureName;
		MountCheck.PetList[i][2] = creatureSpellID;
		MountCheck.PetList[i][3] = icon;
		MountCheck.PetList[i][99] = i;
	end
	
	if(MountCheck.dropdownSelect==1) then
		for j=1,#CombinedMountList do
			MountCheck.CheckList[j] = 0;
			if(#MountCheck.MountList~=0) then
				for k=1,#MountCheck.MountList do	
					if(CombinedMountList[j][2] == tostring(MountCheck.MountList[k][2])) then
						MountCheck.CheckList[j] = 1;
						MountCheck.MountList[k][4] = CombinedMountList[j][3];
						MountCheck.MountList[k][6] = CombinedMountList[j][5];
						if(CombinedMountList[j][6]) then
							MountCheck.MountList[k][5] = CombinedMountList[j][6];
						end
						if(CombinedMountList[j][4]=="100")then
							if(CombinedMountList[j][5]~="AQ Mount") then
								MountCheck.FastLandMounts[a]=MountCheck.MountList[k];
								MountCheck.FastLandMounts[a][7]=k;
								a=a+1;
							end
						end
						if((CombinedMountList[j][4]=="60")or(CombinedMountList[j][4]=="40"))then
							MountCheck.LandMounts[b]=MountCheck.MountList[k];
							MountCheck.LandMounts[b][7]=k;
							b=b+1;
						end
						if(CombinedMountList[j][4]=="150")then
							MountCheck.FlyingMounts[d]=MountCheck.MountList[k];
							MountCheck.FlyingMounts[d][7]=k;
							d=d+1;
						end
						if(CombinedMountList[j][4]=="280")then
							MountCheck.FastFlyingMounts[c]=MountCheck.MountList[k];
							MountCheck.FastFlyingMounts[c][7]=k;
							c=c+1;
						end
						if(CombinedMountList[j][4]=="310")then
							MountCheck.FastFlyingMounts[c]=MountCheck.MountList[k];
							MountCheck.FastFlyingMounts[c][7]=k;
							c=c+1;
						end
					end
				end
			end			
			if(MountCheck.CheckList[j] == 0) then
				MountCheck.NoMountList[x] = {}
				MountCheck.NoMountList[x][1] = CombinedMountList[j][1];
				MountCheck.NoMountList[x][2] = CombinedMountList[j][2];
				MountCheck.NoMountList[x][3] = CombinedMountList[j][3];
				MountCheck.NoMountList[x][5] = CombinedMountList[j][5];
				if(CombinedMountList[j][6]) then
					MountCheck.NoMountList[x][4] = CombinedMountList[j][6];
				end
				x=x+1;
			end
		end
	else
		for l=1,#CombinedPetList do
			MountCheck.PetCheckList[l] = 0;
			if(#MountCheck.PetList~=0) then
				for k=1,#MountCheck.PetList do	
					if(CombinedPetList[l][2] == tostring(MountCheck.PetList[k][2])) then
						MountCheck.PetCheckList[l] = 1;
						MountCheck.PetList[k][4] = CombinedPetList[l][3];
						MountCheck.PetList[k][4] = CombinedPetList[l][3];
						MountCheck.PetList[k][6] = CombinedPetList[l][5];
						
						if(CombinedPetList[l][6]) then
							MountCheck.PetList[k][5] = CombinedPetList[l][6];
						end
					end
				end
			end	
			if(MountCheck.PetCheckList[l] == 0) then
				MountCheck.NoPetList[z] = {}
				MountCheck.NoPetList[z][1] = CombinedPetList[l][1];
				MountCheck.NoPetList[z][2] = CombinedPetList[l][2];
				MountCheck.NoPetList[z][3] = CombinedPetList[l][3];
				MountCheck.NoPetList[z][5] = CombinedPetList[l][5];
				if(CombinedPetList[l][6]) then
					MountCheck.NoPetList[z][4] = CombinedPetList[l][6];
				end
				z=z+1;
			end
		end
	end
	MountCheck.getlistcount = 1;
end

function MountCheck.LinkClicked(ClickedFrame, button)
	local namestring = ClickedFrame:GetName();
	local num = strsub(namestring, 17);
	local spellID = getglobal("MountInfo"..num):GetText();
	local itemID = getglobal("MountInfoTwo"..num):GetText();
	--out("Spell: "..spellID.." item: "..itemID);
	local output="";
	local lineplusoffset = num + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
	
	if(IsShiftKeyDown()) then
		link = GetSpellLink(spellID);
		if (itemID~="-1") then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
			if(itemLink) then
				ChatEdit_InsertLink(itemLink);
			else
				DEFAULT_CHAT_FRAME:AddMessage("Item Link not found on server. Sending Spell Link instead.");
				ChatEdit_InsertLink(link);
			end
		else
			ChatEdit_InsertLink(link);
		end
	end
	
	if(button=="RightButton") then	
			if(MountCheck.dropdownDisplay==1) then
				if(MountCheck.dropdownSelect==1) then
					for i=1,#MountCheck.MountList do
						if(tostring(MountCheck.MountList[i][2]) == tostring(spellID)) then
							CallCompanion("MOUNT",MountCheck.MountList[i][99]);
						end
					end
				end
				if(MountCheck.dropdownSelect==2) then
					--CallCompanion("CRITTER",lineplusoffset);
					for i=1,#MountCheck.PetList do
						if(tostring(MountCheck.PetList[i][2]) == tostring(spellID)) then
							CallCompanion("CRITTER",MountCheck.PetList[i][99]);
						end
					end
				end
			end
	else
		link = GetSpellLink(spellID);
		if(itemID~="-1") then
			--local itemName, itemLink = GetItemInfo(CombinedMountList[clicked][3]); 
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
			if not(itemLink) then						
				GameTooltip:SetHyperlink("item:"..itemID..":0:0:0:0:0:0:0");
				DEFAULT_CHAT_FRAME:AddMessage("Mount Check: Querying server...");
				local f = CreateFrame('Frame')
				local last, throttle = 0, 1 -- 1 second throttle between script execution
				f:SetScript('OnUpdate', function(self, elapsed)
					-- increment time since first redraw
					last = last + elapsed
					-- proceed if a second or more has passed
					if last >= throttle then
						itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
						if(itemLink) then
							output="Item Link: "..itemLink;
							DEFAULT_CHAT_FRAME:AddMessage(output);
						else
							DEFAULT_CHAT_FRAME:AddMessage("Item Link not found on server. Sending Spell Link instead.");
							output="Spell Link: "..link;
							DEFAULT_CHAT_FRAME:AddMessage(output);
						end
						-- reset it for next time
						last = 0
						-- stop it from executing again in a loop
						f:Hide()
					end
					--out(last);
				end)
				-- hidden frames don't trigger onupdate handlers
				--f:Hide()
				f:Show();
			else
				output="Item Link: "..itemLink;
				DEFAULT_CHAT_FRAME:AddMessage(output);
			end
		else
			output="Spell Link: "..link;
			DEFAULT_CHAT_FRAME:AddMessage(output);
		end
	end
end

function MountCheck.MountCheckScrollBar_Update()
	local line;
	local lineplusoffset;

	for line=1,24 do	
		lineplusoffset = line + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
		if not(getglobal("MountCheck_Entry"..line)) then
			local b = CreateFrame("Button","MountCheck_Entry"..line,MountCheck1,"MountCheck_EntryTemplate");
			b:RegisterForClicks('anyUp');
			local a = b:CreateFontString("MountName"..line, "ARTWORK", "GameFontNormalSmall");
			a:SetFont("Fonts\\FRIZQT__.TTF", 11);
			local a2 = b:CreateTexture("MountIcon"..line,"ARTWORK");
			local c = CreateFrame("Button","MountInfo"..line,MountCheck1,"MountCheck_EntryTemplate");
			local d = CreateFrame("Button","MountInfoTwo"..line,MountCheck1,"MountCheck_EntryTemplate");
			local f = CreateFrame("Button","MountInfoSource"..line,MountCheck1,"MountCheck_SourceTemplate");
			local f2 = f:CreateFontString("MountInfoSourceText"..line, "ARTWORK", "GameFontHighlightLeft");
			f2:SetFont("Fonts\\FRIZQT__.TTF", 10);
			if(line%2==0) then
				local e = CreateFrame("Frame","MountCheck_backgroundcolor"..line,MountCheck1,"MountCheck_backgroundcolor1");
			else
				local e = CreateFrame("Frame","MountCheck_backgroundcolor"..line,MountCheck1,"MountCheck_backgroundcolor2");
			end
		end
		if(line==1) then
			getglobal("MountCheck_Entry"..line):SetPoint("TOPLEFT", "MountCheck_ScrollBar", "TOPLEFT", 9, -1);
		else
			getglobal("MountCheck_Entry"..line):SetPoint("TOPLEFT", "MountCheck_Entry"..(line-1), "BOTTOMLEFT", 0, -1);
		end
		getglobal("MountName"..line):SetPoint("TOPLEFT", "MountCheck_Entry"..line, "TOPLEFT", 16, -3);
		getglobal("MountIcon"..line):SetPoint("TOPLEFT", "MountCheck_Entry"..line, "TOPLEFT", 0, -2);
		getglobal("MountCheck_backgroundcolor"..line):SetPoint("TOPLEFT", "MountCheck_Entry"..line, "TOPLEFT", 0, 1);
		getglobal("MountInfoSource"..line):SetPoint("TOPRIGHT", "MountCheck_backgroundcolor"..line, "TOPRIGHT", 0, 1);
		getglobal("MountInfoSourceText"..line):SetPoint("TOPRIGHT", "MountCheck_backgroundcolor"..line, "TOPRIGHT", -2, -3);
		getglobal("MountIcon"..line):SetHeight(14);
		getglobal("MountIcon"..line):SetWidth(14);
		
		if(MountCheck.dropdownSelect==1) then
			--mounts
			if(MountCheck.dropdownDisplay==1) then --collected
				FauxScrollFrame_Update(MountCheck_ScrollBar,#MountCheck.MountList,24,20);
				lineplusoffset = line + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
				if(#MountCheck.MountList > 0) then
					if((lineplusoffset <= #MountCheck.MountList)or(lineplusoffset==1)) then
						getglobal("MountName"..line):SetText(MountCheck.MountList[lineplusoffset][1]);
						if(MountCheck.MountList[lineplusoffset][5]) then
							getglobal("MountName"..line):SetText(MountCheck.MountList[lineplusoffset][1].." "..MountCheck.MountList[lineplusoffset][5]);
						end
						getglobal("MountInfo"..line):SetText(MountCheck.MountList[lineplusoffset][2]);
						getglobal("MountInfoSourceText"..line):SetText(MountCheck.MountList[lineplusoffset][6]);
						getglobal("MountInfoTwo"..line):SetText(MountCheck.MountList[lineplusoffset][4]);
						local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(MountCheck.MountList[lineplusoffset][2]);
						getglobal("MountIcon"..line):SetTexture(MountCheck.MountList[lineplusoffset][3]);
						getglobal("MountCheck_Entry"..line):Show();
						getglobal("MountInfoSourceText"..line):Show();
					else	
						getglobal("MountCheck_Entry"..line):Hide();
						getglobal("MountInfoSourceText"..line):Hide();
					end		
				end
				getglobal("MountCount"):SetText("Collected Mounts: "..#MountCheck.MountList.."/"..#CombinedMountList);				
			end
			
			if(MountCheck.dropdownDisplay==2) then --not collected
				FauxScrollFrame_Update(MountCheck_ScrollBar,#MountCheck.NoMountList,24,20);
				lineplusoffset = line + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
				if((lineplusoffset <= #MountCheck.NoMountList)or((#MountCheck.NoMountList==1)and(lineplusoffset==1))) then
					getglobal("MountName"..line):SetText(MountCheck.NoMountList[lineplusoffset][1]);
					if(MountCheck.NoMountList[lineplusoffset][4]) then
						getglobal("MountName"..line):SetText(MountCheck.NoMountList[lineplusoffset][1].." "..MountCheck.NoMountList[lineplusoffset][4]);
					end
					getglobal("MountInfo"..line):SetText(MountCheck.NoMountList[lineplusoffset][2]);
					getglobal("MountInfoTwo"..line):SetText(MountCheck.NoMountList[lineplusoffset][3]);
					getglobal("MountInfoSourceText"..line):SetText(MountCheck.NoMountList[lineplusoffset][5]);
					local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(MountCheck.NoMountList[lineplusoffset][2]);
					getglobal("MountIcon"..line):SetTexture(icon);
					getglobal("MountCheck_Entry"..line):Show();
					getglobal("MountInfoSourceText"..line):Show();
				else	
					getglobal("MountCheck_Entry"..line):Hide();
					getglobal("MountInfoSourceText"..line):Hide();
				end	
				local p = 263-#MountCheck.MountList;
				if(p~=#MountCheck.NoMountList) then
					getglobal("MountCount"):SetText("Not Collected Mounts: "..p.."/"..#CombinedMountList);	
				else
					getglobal("MountCount"):SetText("Not Collected Mounts: "..#MountCheck.NoMountList.."/"..#CombinedMountList);	
				end
			end
			
			if(MountCheck.dropdownDisplay==3) then --ignored
			
			end
			
		else
			--pets
			if(MountCheck.dropdownDisplay==1) then --collected
				FauxScrollFrame_Update(MountCheck_ScrollBar,#MountCheck.PetList,24,20);
				lineplusoffset = line + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
				if((lineplusoffset <= #MountCheck.PetList)or((#MountCheck.PetList==1)and(lineplusoffset==1))) then
					getglobal("MountName"..line):SetText(MountCheck.PetList[lineplusoffset][1]);
					if(MountCheck.PetList[lineplusoffset][5]) then
						getglobal("MountName"..line):SetText(MountCheck.PetList[lineplusoffset][1].." "..MountCheck.PetList[lineplusoffset][5]);
					end
					getglobal("MountInfo"..line):SetText(MountCheck.PetList[lineplusoffset][2]);
					getglobal("MountInfoTwo"..line):SetText(MountCheck.PetList[lineplusoffset][4]);
					getglobal("MountInfoSourceText"..line):SetText(MountCheck.PetList[lineplusoffset][6]);
					local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(MountCheck.PetList[lineplusoffset][2]);
					getglobal("MountIcon"..line):SetTexture(MountCheck.PetList[lineplusoffset][3]);
					getglobal("MountCheck_Entry"..line):Show();
					getglobal("MountInfoSourceText"..line):Show();
				else	
					getglobal("MountCheck_Entry"..line):Hide();
					getglobal("MountInfoSourceText"..line):Hide();
				end		
				getglobal("MountCount"):SetText("Collected Pets: "..#MountCheck.PetList.."/"..#CombinedPetList);	
			end
			
			if(MountCheck.dropdownDisplay==2) then --notcollected
				FauxScrollFrame_Update(MountCheck_ScrollBar,#MountCheck.NoPetList,24,20);
				lineplusoffset = line + FauxScrollFrame_GetOffset(MountCheck_ScrollBar);
				if((lineplusoffset <= #MountCheck.NoPetList)or((#MountCheck.NoPetList==1)and(lineplusoffset==1))) then
					getglobal("MountName"..line):SetText(MountCheck.NoPetList[lineplusoffset][1]);
					if(MountCheck.NoPetList[lineplusoffset][4]) then
						getglobal("MountName"..line):SetText(MountCheck.NoPetList[lineplusoffset][1].." "..MountCheck.NoPetList[lineplusoffset][4]);
					end
					getglobal("MountInfo"..line):SetText(MountCheck.NoPetList[lineplusoffset][2]);
					getglobal("MountInfoTwo"..line):SetText(MountCheck.NoPetList[lineplusoffset][3]);
					getglobal("MountInfoSourceText"..line):SetText(MountCheck.NoPetList[lineplusoffset][5]);
					local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(MountCheck.NoPetList[lineplusoffset][2]);
					getglobal("MountIcon"..line):SetTexture(icon);
					getglobal("MountCheck_Entry"..line):Show();
					getglobal("MountInfoSourceText"..line):Show();
				else	
					getglobal("MountCheck_Entry"..line):Hide();
					getglobal("MountInfoSourceText"..line):Hide();
				end	
				local p = 160-#MountCheck.PetList;
				if(p~=#MountCheck.NoPetList) then
					getglobal("MountCount"):SetText("Not Collected Pets: "..p.."/"..#CombinedPetList);
				else
					getglobal("MountCount"):SetText("Not Collected Pets: "..#MountCheck.NoPetList.."/"..#CombinedPetList);	
				end
			end
			
			if(MountCheck.dropdownDisplay==3) then --ignored
			end
		end
	end
end

function MountCheck.createDropdown1()
	if not MountCheck_DropDownMenu then
	   CreateFrame("Frame", "MountCheck_DropDownMenu", MountCheck1, "UIDropDownMenuTemplate")
	end

	MountCheck_DropDownMenu:ClearAllPoints();
	MountCheck_DropDownMenu:SetPoint("TOPLEFT", MountCheck1, -7, -11);
	MountCheck_DropDownMenu:Show();

	local items = {
	   "Mounts",
	   "Pets",
	}

	local function OnClick(self)
	   UIDropDownMenu_SetSelectedID(MountCheck_DropDownMenu, self:GetID());
	   MountCheck.dropdownSelect = self:GetID();
	   MountCheck.getMountList();
	   MountCheck.ShowScroll();
	end

	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
		  info = UIDropDownMenu_CreateInfo()
		  info.text = v
		  info.value = v
		  info.func = OnClick
		  UIDropDownMenu_AddButton(info, level)
	   end
	end


	UIDropDownMenu_Initialize(MountCheck_DropDownMenu, initialize)
	UIDropDownMenu_SetWidth(MountCheck_DropDownMenu, 80);
	UIDropDownMenu_SetButtonWidth(MountCheck_DropDownMenu, 104)
	UIDropDownMenu_SetSelectedID(MountCheck_DropDownMenu, 1)
	UIDropDownMenu_JustifyText(MountCheck_DropDownMenu, "LEFT")
	MountCheck.Mountcheckcount = 1;
end

function MountCheck.createDropdown2()
	if not MountCheck_DropDownMenu2 then
	   CreateFrame("Frame", "MountCheck_DropDownMenu2", MountCheck1, "UIDropDownMenuTemplate")
	end

	MountCheck_DropDownMenu2:ClearAllPoints();
	MountCheck_DropDownMenu2:SetPoint("TOPRIGHT", MountCheck1, -8, -11);
	MountCheck_DropDownMenu2:Show();

	local items = {
	   "Collected",
	   "Not Collected",
	   --"Ignored",
	}

	local function OnClick(self)
	   UIDropDownMenu_SetSelectedID(MountCheck_DropDownMenu2, self:GetID());
	   MountCheck.dropdownDisplay = self:GetID();
	   MountCheck.getMountList();
	   MountCheck.ShowScroll();
	  -- out(dropdownDisplay)
	end

	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
		  info = UIDropDownMenu_CreateInfo()
		  info.text = v
		  info.value = v
		  info.func = OnClick
		  UIDropDownMenu_AddButton(info, level)
	   end
	end


	UIDropDownMenu_Initialize(MountCheck_DropDownMenu2, initialize)
	UIDropDownMenu_SetWidth(MountCheck_DropDownMenu2, 96);
	UIDropDownMenu_SetButtonWidth(MountCheck_DropDownMenu2, 20)
	UIDropDownMenu_SetSelectedID(MountCheck_DropDownMenu2, 1)
	UIDropDownMenu_JustifyText(MountCheck_DropDownMenu2, "LEFT")
end
